diff --git a/tests/bugs/step/bug28256 b/tests/bugs/step/bug28256
index da63f8e..f752898 100644
--- a/tests/bugs/step/bug28256
+++ b/tests/bugs/step/bug28256
@@ -12,16 +12,16 @@ tpcompound result
 checkprops result -s 1.8e+101 
 
 set nbshapes_expected "
-Number of shapes in shape
+Number of shapes in result
  VERTEX    : 56881
  EDGE      : 85310
  WIRE      : 37795
- FACE      : 32992
+ FACE      : 32990
  SHELL     : 1318
  SOLID     : 1308
  COMPSOLID : 0
  COMPOUND  : 1
- SHAPE     : 215605
+ SHAPE     : 215603
 "
 checknbshapes result -ref ${nbshapes_expected} -t -m "importing file"
 checkview -display result -3d -path ${imagedir}/${test_image}.png
\ No newline at end of file
diff --git a/tests/de/iges_2/H4 b/tests/de/iges_2/H4
index 8518edb..c5c30c3 100755
--- a/tests/de/iges_2/H4
+++ b/tests/de/iges_2/H4
@@ -3,6 +3,7 @@ puts "TODO CR23096 ALL: DATA : Faulty"
 puts "TODO CR23096 ALL: LABELS : Faulty" 
 puts "TODO CR23096 ALL: COLORS : Faulty" 
 puts "TODO CR23096 ALL: LAYERS : Faulty" 
+puts "TODO CR28805 ALL: 3 differences with reference data found"
 
 
 set filename UKI60028-2.igs
diff --git a/tests/de/iges_3/A1 b/tests/de/iges_3/A1
index 5a983e6..c331fa9 100644
--- a/tests/de/iges_3/A1
+++ b/tests/de/iges_3/A1
@@ -3,6 +3,7 @@ puts "TODO CR23096 ALL: NBSHAPES : Faulty"
 puts "TODO CR23096 ALL: STATSHAPE : Faulty" 
 puts "TODO CR23096 ALL: LABELS : Faulty" 
 puts "TODO CR23096 ALL: COLORS : Faulty" 
+puts "TODO CR28805 ALL: 3 differences with reference data found"
 
 
 set filename PUNZONE.igs
diff --git a/tests/de/step_3/E6 b/tests/de/step_3/E6
index 5ddfd3c..096ca74 100755
--- a/tests/de/step_3/E6
+++ b/tests/de/step_3/E6
@@ -3,6 +3,7 @@ puts "TODO CR23096 ALL:  Update of 3D-Parameters has failed"
 puts "TODO CR23096 ALL: CHECKSHAPE : Faulty" 
 puts "TODO CR23096 ALL: NBSHAPES : Faulty" 
 puts "TODO CR23096 ALL: STATSHAPE : Faulty" 
+puts "TODO CR28805 ALL: 2 differences with reference data found"
 
 
 set filename Z8M6SAT.stp
diff --git a/tests/heal/fix_shape/A1 b/tests/heal/fix_shape/A1
index 3c415fe..bd3cd9f 100644
--- a/tests/heal/fix_shape/A1
+++ b/tests/heal/fix_shape/A1
@@ -1,2 +1,11 @@
-puts "TODO OCC23127 ALL: Faulty shapes in variables faulty_1 to faulty_1"
+#puts "TODO OCC28863 ALL: Faulty shapes in variables faulty_1 to faulty_1"
+
+# Simple cylindrical face.
+# P-curve of the "top"-edge is geometrically
+# attached to the "bottom" one.
+# ShapeFix does not translate incorrect p-curve.
+# It increases the tolerance only in order to make the face be closed.
+# However, the current version of checkshape does not report about
+# self-intersecting.
+
 restore [locate_data_file aaa.rle] a
diff --git a/tests/heal/fix_shape/F7 b/tests/heal/fix_shape/F7
index 7e94fe7..b4f4979 100644
--- a/tests/heal/fix_shape/F7
+++ b/tests/heal/fix_shape/F7
@@ -1,2 +1,11 @@
-puts "TODO OCC23127 ALL: Faulty shapes in variables faulty_1 to faulty_1"
+#puts "TODO OCC28863 ALL: Faulty shapes in variables faulty_1 to faulty_1"
+
+# Simple cylindrical face.
+# P-curve of the "top"-edge is geometrically
+# attached to the "bottom" one.
+# ShapeFix does not translate incorrect p-curve.
+# It increases the tolerance only in order to make the face be closed.
+# However, the current version of checkshape does not report about
+# self-intersecting.
+
 restore [locate_data_file rrr.rle] a
diff --git a/tests/heal/surface_to_bspline/F2 b/tests/heal/surface_to_bspline/F2
index baec327..d00f9f3 100644
--- a/tests/heal/surface_to_bspline/F2
+++ b/tests/heal/surface_to_bspline/F2
@@ -1,3 +1,3 @@
-puts "TODO OCC23127 ALL: Faulty shapes in variables faulty_1 to faulty_2"
+puts "TODO OCC23127 ALL: Faulty shapes in variables faulty_1 to faulty_1"
 
 restore [locate_data_file rrr.rle] a
diff --git a/tests/lowalgos/classifier/buc60609 b/tests/lowalgos/classifier/buc60609
new file mode 100644
index 0000000..d3c1737
--- /dev/null
+++ b/tests/lowalgos/classifier/buc60609
@@ -0,0 +1,21 @@
+puts "================"
+puts "BUC60609"
+puts "================"
+
+restore [locate_data_file buc60609a.brep] a
+
+# two points will be classified
+point p1 0.14 5.1
+point p2 1.28 5.1
+
+if {![regexp "IN" [b2dclassify a p1]]} {
+  puts "Faulty BUC60609 first: $first is not right result. It should be INSIDE"
+} else {
+  puts "BUC60609 first OK:  It is INSIDE"
+}
+
+if {![regexp "IN" [b2dclassify a p2]]} {
+  puts "Faulty BUC60609 second: $second is not right result. It should be INSIDE"
+} else {
+  puts "BUC60609 second OK:  It is INSIDE"
+}
diff --git a/tests/lowalgos/classifier/bug22494 b/tests/lowalgos/classifier/bug22494
new file mode 100644
index 0000000..de0bf2b
--- /dev/null
+++ b/tests/lowalgos/classifier/bug22494
@@ -0,0 +1,26 @@
+puts "================"
+puts "OCC22494"
+puts "================"
+puts ""
+#######################################################################
+# BRepClass_FaceClassifier bug (ref SALOME issue 21185)
+#######################################################################
+
+set BugNumber OCC22494
+
+restore [locate_data_file bug22494_Pb_belogToGeom_FACE.brep] Face 
+
+point p -3.53254182396379145e-05 0.000877856930738714065
+
+set res [split [b2dclassify Face p] ]
+
+set ll [llength ${res}]
+if {${ll} < 4} {
+   puts "Bad format of bclassify draw-command; Faulty ${BugNumber}"
+} else {
+   if {[regexp {The point is ON shape} $res]} {
+      puts "OK ${BugNumber}"
+   } else {
+      puts "Faulty ${BugNumber}"
+   }
+}
diff --git a/tests/lowalgos/classifier/bug23244 b/tests/lowalgos/classifier/bug23244
new file mode 100644
index 0000000..729163a
--- /dev/null
+++ b/tests/lowalgos/classifier/bug23244
@@ -0,0 +1,36 @@
+puts "================"
+puts "OCC23244"
+puts "================"
+puts ""
+#######################################################################
+# Bug of BRepClass_FaceClassifier: it does not take into account the tolerance
+#######################################################################
+
+set BugNumber OCC23244
+
+restore [locate_data_file OCC23244-comp.brep] a
+
+explode a
+explode a_1
+
+smallview
+donly a_1_2 a_3
+fit
+
+mkpoint p3 a_3
+projponf a_1_2 p3
+point pp3 69.220445243320853 1216.6123701316949
+
+set result [split [b2dclassify a_1_2 pp3 -t 1.e-5] ]
+
+set ll [llength ${result}]
+if {${ll} < 4} {
+   puts "Bad format of bclassify draw-command; Faulty ${BugNumber}"
+} else {
+   if { [regexp "ON" $result] == 1 } {
+      puts "OK ${BugNumber}"
+   } else {
+      puts "Faulty ${BugNumber}"
+   }
+}
+
diff --git a/tests/lowalgos/classifier/bug23341 b/tests/lowalgos/classifier/bug23341
new file mode 100644
index 0000000..c78461b
--- /dev/null
+++ b/tests/lowalgos/classifier/bug23341
@@ -0,0 +1,21 @@
+puts "================"
+puts "OCC23341"
+puts "================"
+puts ""
+#######################################################################
+# Wrong result done by 2D classifier algorithm for a point and a face
+#######################################################################
+
+set BugNumber OCC23341
+
+restore [locate_data_file bug23341_f1] f1
+restore [locate_data_file bug23341_p] p
+set info [b2dclassify f1 p]
+set check [regexp "OUT" $info]
+
+if { ${check} == 1 } {
+    puts "OK ${BugNumber}"
+} else {
+    puts "Faulty ${BugNumber}"
+}
+
diff --git a/tests/lowalgos/classifier/bug23777 b/tests/lowalgos/classifier/bug23777
new file mode 100644
index 0000000..f02473f
--- /dev/null
+++ b/tests/lowalgos/classifier/bug23777
@@ -0,0 +1,22 @@
+puts "================"
+puts "OCC23777"
+puts "================"
+puts ""
+#######################################################################
+# 2D-Classifier algorithm produces wrong results for a point and face.
+#######################################################################
+
+set BugNumber OCC23777
+
+restore [locate_data_file bug23777_b1.brep] b1
+
+point p2D 0.062260538576946696 249583.00418413401
+
+set info [b2dclassify b1 p2D]
+set check [regexp "IN" $info]
+
+if { ${check} == 1 } {
+    puts "OK ${BugNumber}"
+} else {
+    puts "Faulty ${BugNumber}"
+}
diff --git a/tests/lowalgos/classifier/bug23849_2 b/tests/lowalgos/classifier/bug23849_2
new file mode 100644
index 0000000..504542b
--- /dev/null
+++ b/tests/lowalgos/classifier/bug23849_2
@@ -0,0 +1,23 @@
+puts "================"
+puts "OCC23849"
+puts "================"
+puts ""
+#######################################################################
+# BOP regression
+#######################################################################
+
+set BugNumber OCC23849
+
+restore [locate_data_file bug23849_segment_1.brep] b1
+explode b1 f
+
+point p2D 4.1882396063720497 50.643343428894831
+
+set info [b2dclassify b1_1 p2D]
+set check [regexp "IN" $info]
+
+if { ${check} == 1 } {
+    puts "OK ${BugNumber}"
+} else {
+    puts "Faulty ${BugNumber}"
+}
diff --git a/tests/lowalgos/classifier/bug24422 b/tests/lowalgos/classifier/bug24422
new file mode 100644
index 0000000..d16fcfc
--- /dev/null
+++ b/tests/lowalgos/classifier/bug24422
@@ -0,0 +1,25 @@
+puts "================"
+puts "OCC24422"
+puts "================"
+puts ""
+#######################################################################
+# Wrong result done by FaceClassifier algorythm
+#######################################################################
+
+restore [locate_data_file bug24422_Compound.brep] b 
+explode b f
+copy b_1 f
+
+point p 115.945392440981 106 230.000108990528
+point p_proj 230.00010899052799 1925.9453924409811
+set info [b2dclassify f p_proj]
+
+if { [regexp "The point is OUT of shape" $info] != 1  } {
+    puts "Error : point should be ON shape"
+} else {
+    puts "OK: point is OUT of shape"
+}
+
+axo
+fit
+checkview -screenshot -2d -path ${imagedir}/${test_image}.png
diff --git a/tests/lowalgos/classifier/bug25969 b/tests/lowalgos/classifier/bug25969
new file mode 100644
index 0000000..4c190ff
--- /dev/null
+++ b/tests/lowalgos/classifier/bug25969
@@ -0,0 +1,37 @@
+puts "================"
+puts "CR25969"
+puts "================"
+puts ""
+###############################################
+## Wrong result obtained by 2d classifier algorithm.
+###############################################
+
+pload DCAF
+
+Open [locate_data_file bug25969_pal22851.cbf] D
+
+GetShape D 0:1:15:1:1:2 b1
+GetShape D 0:1:29:1:1:2 b2
+ 
+explode b1
+explode b2
+ 
+bop b1_2 b2_1
+bopcut r
+
+explode r f
+copy r_4 f
+pcurve f
+ 
+point p 12.658283198213592 21.045164979270297 
+ 
+set cls1 [b2dclassifx f p]
+if { [regexp {OUT} $cls1] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+smallview
+fit
+checkview -screenshot -2d -path ${imagedir}/${test_image}.png
diff --git a/tests/lowalgos/classifier/bug25969_std b/tests/lowalgos/classifier/bug25969_std
new file mode 100644
index 0000000..a672786
--- /dev/null
+++ b/tests/lowalgos/classifier/bug25969_std
@@ -0,0 +1,37 @@
+puts "================"
+puts "CR25969"
+puts "================"
+puts ""
+###############################################
+## Wrong result obtained by 2d classifier algorithm.
+###############################################
+
+pload DCAF
+
+Open [locate_data_file bug25969_pal22851.sgd] D
+
+GetShape D 0:1:15:1:1:2 b1
+GetShape D 0:1:29:1:1:2 b2
+ 
+explode b1
+explode b2
+ 
+bop b1_2 b2_1
+bopcut r
+
+explode r f
+copy r_4 f
+pcurve f
+ 
+point p 12.658283198213592 21.045164979270297 
+ 
+set cls1 [b2dclassifx f p]
+if { [regexp {OUT} $cls1] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+smallview
+fit
+set only_screen_axo 1
diff --git a/tests/lowalgos/classifier/bug26206 b/tests/lowalgos/classifier/bug26206
new file mode 100644
index 0000000..263226b
--- /dev/null
+++ b/tests/lowalgos/classifier/bug26206
@@ -0,0 +1,26 @@
+puts "================"
+puts "OCC26206"
+puts "================"
+puts ""
+#######################################################################
+# BRepClass_FaceClassifier returns TopAbs_OUT for internal point
+#######################################################################
+
+restore [locate_data_file bug26206_group_1.brep] a
+
+point p 0.012676794773312086 0.04799218752935417
+
+set info [b2dclassify a p -t 1e-05]
+
+if { [regexp "The point is IN shape" $info] == 1  } {
+    puts "OK: point is IN shape"
+} else {
+    puts "Error : point should be IN shape"
+}
+
+pcurve a
+
+#v2d2
+view 1 -2D-  728 20 400 400
+2dfit
+xwd ${imagedir}/${test_image}.png
diff --git a/tests/lowalgos/classifier/bug27434 b/tests/lowalgos/classifier/bug27434
new file mode 100644
index 0000000..efef2c5
--- /dev/null
+++ b/tests/lowalgos/classifier/bug27434
@@ -0,0 +1,21 @@
+puts "============"
+puts "OCC27434"
+puts "============"
+puts ""
+###############################
+## Wrong result of classification of the point in "infinity".
+###############################
+
+set BugNumber OCC27434
+
+restore [locate_data_file bug27434_ff.brep] ff
+point pp 3.5104958975622309 1.4497931574922160e+031
+
+set info [b2dclassify ff pp]
+set check [regexp "OUT" $info]
+
+if { ${check} == 1 } {
+    puts "OK ${BugNumber}"
+} else {
+    puts "Faulty ${BugNumber}"
+}
diff --git a/tests/lowalgos/classifier/bug28211_10 b/tests/lowalgos/classifier/bug28211_10
new file mode 100644
index 0000000..25df0a8
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_10
@@ -0,0 +1,36 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# We create new face, which is not-closed in 2D- and 3D-space.
+# The face contains only single edge (with FORWARD-orientation)
+# and single vertex, which covers the gap.
+# After that, point is classified, which is
+# out of the face UV-bounds.
+
+circle cc 0 0 0 0 0 1 100
+trim cc cc 0.0001 2*pi-0.0001
+vertex vv 100 0 0
+mkedge ee cc
+emptycopy ee ee
+settolerance vv 0.05
+copy vv vr
+orientation vr R
+add vv ee
+add vr ee
+wire ww ee
+mkplane result ww
+
+checkshape result
+
+point pp 100.002 0.0
+
+if { ![regexp {OUT} [ b2dclassify result pp ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
diff --git a/tests/lowalgos/classifier/bug28211_11 b/tests/lowalgos/classifier/bug28211_11
new file mode 100644
index 0000000..6c528be
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_11
@@ -0,0 +1,37 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# We create new face, which is not-closed in 2D- and 3D-space.
+# The face contains only single edge (with REVERSED-orientation)
+# and single vertex, which covers the gap.
+# After that, point is classified, which is
+# out of the face UV-bounds.
+
+circle cc 0 0 0 0 0 1 100
+trim cc cc 0.0001 2*pi-0.0001
+vertex vv 100 0 0
+mkedge ee cc
+emptycopy ee ee
+settolerance vv 0.05
+copy vv vr
+orientation vr R
+orientation ee R
+add vv ee
+add vr ee
+wire ww ee
+mkplane result ww
+
+checkshape result
+
+point pp 100.002 0.0
+
+if { ![regexp {OUT} [ b2dclassify result pp ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
diff --git a/tests/lowalgos/classifier/bug28211_12 b/tests/lowalgos/classifier/bug28211_12
new file mode 100644
index 0000000..789e24e
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_12
@@ -0,0 +1,49 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# The face contains two edges
+# connected by their two vertices.
+# More over, two edges are connected by shared vertices
+# from one side and (from other side) by vertices,
+# which are common with seam:
+#
+#                  *************************
+#                  *                       *
+#            seam  *                       *  seam
+#                  *  edge1         edge2  *
+#                  * ********    ********* *
+#                  V1        V2   V3       V4
+#
+#  V1 - vertex between edge1 and seam
+#  V4 - vertex between edge2 and seam
+
+
+
+restore [locate_data_file bug28211_halfclosed.brep] result
+
+nbshapes result
+
+point pp 0.50013085652508904 -1.4847823204826136
+
+if { ![regexp {OUT} [ b2dclassifx result pp ] ] } {
+    puts "Error : Wrong result of b2dclassifx algorithm"
+} else {
+    puts "OK : Good result of b2dclassifx algorithm"
+}
+
+if { ![regexp {OUT} [ b2dclassify result pp ] ] } {
+    puts "Error : Wrong result of b2dclassify algorithm"
+} else {
+    puts "OK : Good result of b2dclassify algorithm"
+}
+
+v2d
+pcurve result
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}.png
diff --git a/tests/lowalgos/classifier/bug28211_13 b/tests/lowalgos/classifier/bug28211_13
new file mode 100644
index 0000000..8a85425
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_13
@@ -0,0 +1,34 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# The face is not closed. Moreover, it contains NOT-CLOSED edge,
+# which has only single vertex and is covered by it.
+
+restore [locate_data_file bug28211_wface.brep] result
+
+nbshapes result
+
+point pp 3.4250396753448720 -12.076599999999999
+
+if { ![regexp {OUT} [ b2dclassifx result pp ] ] } {
+    puts "Error : Wrong result of b2dclassifx algorithm"
+} else {
+    puts "OK : Good result of b2dclassifx algorithm"
+}
+
+if { ![regexp {OUT} [ b2dclassify result pp ] ] } {
+    puts "Error : Wrong result of b2dclassify algorithm"
+} else {
+    puts "OK : Good result of b2dclassify algorithm"
+}
+
+v2d
+pcurve result
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}.png
diff --git a/tests/lowalgos/classifier/bug28211_14 b/tests/lowalgos/classifier/bug28211_14
new file mode 100644
index 0000000..5f69001
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_14
@@ -0,0 +1,47 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# We create new face, which is not-closed in 2D-space.
+# This gap is created between two 2D-representations
+# of seam-edges (it is known fact that seam-edge has
+# two p-curves on the face) and is covered by the tolerance
+# of the vertex, which is shared between two edges.
+# After that, point is classified, which is
+# out of the face UV-bounds.
+
+plane pl 0 0 0 0 0 1
+pcylinder cy pl 1 100
+explode cy f
+emptycopy result cy_1
+explode cy_1 e
+copy cy_1_1 e1
+copy cy_1_2 e2
+copy cy_1_2 e3
+orientation e2 F
+orientation e3 R
+wire ww e1 e2 e3
+add ww result
+
+explode result v
+settolerance result_2 10
+
+checkshape result
+
+point pp 3.5 -10
+
+if { ![regexp {OUT} [ b2dclassifx result pp ] ] } {
+    puts "Error : Wrong result of b2dclassifx algorithm"
+} else {
+    puts "OK : Good result of b2dclassifx algorithm"
+}
+
+if { ![regexp {OUT} [ b2dclassify result pp ] ] } {
+    puts "Error : Wrong result of b2dclassify algorithm"
+} else {
+    puts "OK : Good result of b2dclassify algorithm"
+}
diff --git a/tests/lowalgos/classifier/bug28211_15 b/tests/lowalgos/classifier/bug28211_15
new file mode 100644
index 0000000..965af7e
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_15
@@ -0,0 +1,35 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# The face is self-interfered but valid because
+# this region is covered by the vertex tolerance
+# Before the fix, IntTools_FClass2d returned incorrect result.
+
+binrestore [locate_data_file bug28211_preadb7.brep] result
+
+checkshape result
+
+point pp -0.25003275806782399 5.9730635985427503
+
+if { ![regexp {OUT} [ b2dclassifx result pp ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {OUT} [ b2dclassify result pp ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+v2d
+pcurve result
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}.png
diff --git a/tests/lowalgos/classifier/bug28211_16 b/tests/lowalgos/classifier/bug28211_16
new file mode 100644
index 0000000..35ff15a
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_16
@@ -0,0 +1,35 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# The face seems to be valid. But classified point is near to 
+# the corner (in 2D-space). So, many classification rays are tangent to
+# the existing ones or "goes" through the vertex.
+
+binrestore [locate_data_file bug28211_goodface.brep] result
+
+checkshape result
+
+point pp 336.9868940694347 491.1361705159796
+
+if { ![regexp {OUT} [ b2dclassifx result pp ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {OUT} [ b2dclassify result pp ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+v2d
+pcurve result
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}.png
diff --git a/tests/lowalgos/classifier/bug28211_17 b/tests/lowalgos/classifier/bug28211_17
new file mode 100644
index 0000000..b511dbb
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_17
@@ -0,0 +1,29 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# The face seems to be valid but quite big (in 2D-space).
+# So, (almost) all classification rays are almost
+# tangent to existing ones.
+
+binrestore [locate_data_file bug28211_bigface.brep] result
+
+checkshape result
+
+point pp -3.1415926535980878 -63835.740811028722
+
+if { ![regexp {OUT} [ b2dclassifx result pp ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {OUT} [ b2dclassify result pp ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
diff --git a/tests/lowalgos/classifier/bug28211_18 b/tests/lowalgos/classifier/bug28211_18
new file mode 100644
index 0000000..da7e4f6
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_18
@@ -0,0 +1,60 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# The classified face is based on the sphere and seems to be valid.
+# As far as we know, the sphere is not periodic in V-direction.
+# However, its equation contains only periodic trigonometric
+# function of V (x=f1(U)*cos(V), y=f2(U)*cos(V), z=R*sin(V),
+# where f1(U) and f2(U) are some (periodic) functions with
+# argument U, R is the radius of the sphere). Therefore,
+# if we decline to limit V-range of the sphere in the traditional
+# boundaries [-pi/2; +pi/2] the sphere will be true periodic in V-direction.
+# So, despite taking the classified point pp too far from the face domain
+# (in V-direction) it will be "converted" to the valid 3D-point ON the
+# some edge of the classified face. As result, there is a danger
+# to return ON-status from the classification algorithm. However,
+# it must return OUT.
+
+binrestore [locate_data_file bug28211_sphereon.brep] result
+
+checkshape result
+
+set px pi
+set py -2*pi
+
+point pp $px $py
+
+mksurface ss result
+svalue ss $px $py xx yy zz
+vertex vv xx yy zz
+
+smallview 
+donly result vv
+fit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_3d.png
+
+if { ![regexp {OUT} [ b2dclassifx result pp ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {OUT} [ b2dclassify result pp ] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+v2d
+2dclear
+display pp
+pcurve result
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_2d.png
diff --git a/tests/lowalgos/classifier/bug28211_19 b/tests/lowalgos/classifier/bug28211_19
new file mode 100644
index 0000000..c4edc7b
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_19
@@ -0,0 +1,39 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# The tolerance for classification (Toler = 1.0e-4) is enough
+# for returning ON-status.
+# However, b2dclassifx returned wrong result before the fix.
+
+set Toler 1.0e-4
+
+binrestore [locate_data_file bug28211_forblentTBSC1.brep] result
+
+checkshape result
+
+point pp 0.0010616212616224041 -4.5622747218199273e-005
+
+if { ![regexp {ON} [ b2dclassifx result pp -t $Toler] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {ON} [ b2dclassify result pp -t $Toler] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+v2d
+2dclear
+display pp
+pcurve result
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_2d.png
diff --git a/tests/lowalgos/classifier/bug28211_2 b/tests/lowalgos/classifier/bug28211_2
new file mode 100644
index 0000000..e44412a
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_2
@@ -0,0 +1,69 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# We create new face, which is not-closed in 2D-space.
+# This gap is covered by the tolerance of the vertex
+# and this vertex is shared between two edges.
+# After that, point is classified, which is
+# out of the face UV-bounds.
+
+box b1 10 10 1
+copy b1 b2
+btranslate b2 -10 0 0
+sewing bb b1 b2
+
+explode bb f
+
+explode bb_3 v
+copy bb_3_2 v1
+copy bb_3_3 v2
+copy bb_3_4 v3
+settolerance v1 1.5
+
+explode bb_3 e
+emptycopy e1 bb_3_2
+emptycopy e2 bb_3_3
+emptycopy e3 bb_3_4
+
+add v1 e1
+copy v1 v1c
+orientation v1c R
+
+add v2 e1
+copy v2 v2c
+orientation v2c F
+
+add v2c e2
+add v3 e2
+copy v3 v3c
+orientation v3c F
+
+add v3c e3
+add v1c e3
+
+wire w1 e1 e2 e3
+
+buildfaces f1 bb_3 w1
+explode f1 f
+copy f1_1 result
+
+checkshape result
+
+point pp 0.5 10
+
+if { ![regexp {OUT} [ b2dclassifx result pp ] ] } {
+    puts "Error : Wrong result of b2dclassifx algorithm"
+} else {
+    puts "OK : Good result of b2dclassifx algorithm"
+}
+
+if { ![regexp {OUT} [ b2dclassify result pp ] ] } {
+    puts "Error : Wrong result of b2dclassify algorithm"
+} else {
+    puts "OK : Good result of b2dclassify algorithm"
+}
diff --git a/tests/lowalgos/classifier/bug28211_20 b/tests/lowalgos/classifier/bug28211_20
new file mode 100644
index 0000000..99a1e31
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_20
@@ -0,0 +1,43 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# Before the fix, "b2dclassify" returned ON-status but
+# b2dclassifx returned OUT. After the fix, both
+# commands will return ON.
+# More over, the face is invalid:
+# InvalidCurveOnSurface and InvalidSameParameterFlag.
+
+puts "REQUIRED All: Faulty shapes in variables faulty_1 to faulty_2"
+
+set Toler 1.0e-7
+
+binrestore [locate_data_file bug28211_forhlr25908.brep] result
+
+checkshape result
+
+point pp 0.38952064924606344 1.8145650971005813
+
+if { ![regexp {ON} [ b2dclassifx result pp -t $Toler] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {ON} [ b2dclassify result pp -t $Toler] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+v2d
+2dclear
+display pp
+pcurve result
+2dfit
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_2d.png
diff --git a/tests/lowalgos/classifier/bug28211_21 b/tests/lowalgos/classifier/bug28211_21
new file mode 100644
index 0000000..01f49c9
--- /dev/null
+++ b/tests/lowalgos/classifier/bug28211_21
@@ -0,0 +1,43 @@
+puts "========"
+puts "OCC28211"
+puts "========"
+puts ""
+#################################################
+# Modeling Algorithms - Boolean fuse operation produces incorrect result
+#################################################
+
+# Classified point is IN indeed. However, we should
+# use "discr"-command (for v2d) in order to see it.
+# As result, classifier (which is based
+# on internal polygon) can create not precise polygon
+# and consequently return OUT-status.
+
+binrestore [locate_data_file bug28211_sharpface.brep] result
+
+checkshape result
+
+point pp 0.00071766949562590554 0.00070359754473026115
+
+if { ![regexp {IN} [ b2dclassifx result pp] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+if { ![regexp {IN} [ b2dclassify result pp] ] } {
+    puts "Error : Wrong result of 2d classifier algorithm"
+} else {
+    puts "OK : Good result of 2d classifier algorithm"
+}
+
+v2d
+display pp
+point p1t 0.00057279468289550453 0.00048191679048087871
+point p2t 0.00086390560797472069 0.00077038810872647509
+2dfit
+2dclear
+discr 1000
+display pp
+pcurve result
+
+checkview -screenshot -2d -path ${imagedir}/${test_image}_2d.png
